%define anolis_release 1

%global _lto_cflags %{nil}
%define cuda_version 12.6
%define cuda_ver 12-6

Name: libnccl
Version: 2.22.3
Release: %{anolis_release}.cuda%{cuda_version}%{?dist}
Summary: NVIDIA Collective Communication Library (NCCL) Runtime
License: BSD
URL: http://developer.nvidia.com/nccl
Source0: https://github.com/NVIDIA/nccl/archive/refs/tags/v%{version}-1.tar.gz#/nccl-%{version}-1.tar.gz
Patch1000: 1000-fix-lib-path-in-nccl.pc.patch

BuildRequires: cuda-%{cuda_ver}
ExclusiveArch: x86_64 aarch64

%description
NCCL (pronounced "Nickel") is a stand-alone library of standard collective
communication routines for GPUs, implementing all-reduce, all-gather, reduce,
broadcast, and reduce-scatter.
It has been optimized to achieve high bandwidth on any platform using PCIe,
NVLink, NVswitch, as well as networking using InfiniBand Verbs or TCP/IP
sockets.

%package devel
Summary: NCCL development files
Requires: %{name} = %{version}-%{release}

%description devel
NCCL development files

%package static
Summary: NCCL static library
Requires: %{name}-devel = %{version}-%{release}

%description static
NCCL static library

%prep
%autosetup -p1 -n nccl-%{version}-1

%build
export LD_LIBRARY_PATH=/usr/local/cuda-%{cuda_ver}/lib64
export CFLAGS=usr/local/cuda-%{cuda_ver}/include:$CFLAGS
export PREFIX=/usr
%make_build

%install
mkdir -p %{buildroot}
mkdir -p %{buildroot}%{_includedir}
mkdir -p %{buildroot}%{_libdir}
mkdir -p %{buildroot}%{_libdir}/pkgconfig
cp -d build/lib/libnccl* %{buildroot}%{_libdir}
cp build/include/* %{buildroot}%{_includedir}
cp build/lib/pkgconfig/nccl.pc %{buildroot}%{_libdir}/pkgconfig/

%files
%license LICENSE.txt
%{_libdir}/libnccl.so.*

%files devel
%license LICENSE.txt
%{_includedir}/*.h
%{_libdir}/libnccl.so
%{_libdir}/pkgconfig/nccl.pc

%files static
%license LICENSE.txt
%{_libdir}/libnccl_static.a

%changelog
* Mon Sep 02 2024 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.22.3-1.cuda12.6
- rebuild for cuda12.6

* Wed Aug 14 2024 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.22.3-1
- update to 2.22.3 for cuda 12.5

* Wed Jun 19 2024 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.20.5-1
- update to 2.20.5

* Mon Feb 05 2024 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.19.3-1
- update to 2.19.3

* Tue Aug 22 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.18.3-2
- disable lto

* Thu Jul 13 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.18.3-1
- init from upstream
